<?php
declare(strict_types=1);

namespace App\Doctrine\Core;

use App\Doctrine\AbstractExtension;
use App\Entity\Access\Access;
use App\Entity\Core\AddressPostal;
use Doctrine\ORM\QueryBuilder;
use Symfony\Bundle\SecurityBundle\Security;

/**
 * Class AllowedAddressPostalExtension : Filtre de sécurité par défaut pour une resource AddressPostal
 * @package App\Doctrine\Core
 */
final class AllowedAddressPostalExtension extends AbstractExtension
{
    public function __construct(private Security $security)
    { }

    protected function addWhere(QueryBuilder $queryBuilder, string $resourceClass): void
    {
        if (AddressPostal::class !== $resourceClass) {
            return;
        }

        /** @var Access $currentUser */
        $currentUser = $this->security->getUser();
        $rootAlias = $queryBuilder->getRootAliases()[0];
        $queryBuilder
            ->innerJoin(sprintf('%s.organizationAddressPostal', $rootAlias), 'organization_address_postal')
            ->andWhere('organization_address_postal.organization = :organization')
            ->setParameter('organization', $currentUser->getOrganization())
        ;
    }
}
